// Example by Colombian Developers / GECA soft

program mi_programa;

#include "jkeys.lib"

/*
 YETI ENGINE
 
  y 
  ^     z
  !   /
  ! /
  *------->x
  
  LOAD MAP TEST

*/


const
  mode8_width=320;      //res. Limit is 640x480 max.
  mode8_height=240;
end;


type TYetiKeyState
  int up,down,left,right;  
   int mousex,mousey;
end ;  

type entity_pos
  int   radius;         // 8:8 entity radius.
  int   x, xx;          // 8:8 X position and velocity.
  int   y, yy;          // 8:8 Y position and velocity.
  int   z, zz;          // 8:8 Z position and velocity.
  int   p, pp;          // Pitch and pitch velocity.
  int   r, rr;          // Roll and roll velocity.
  int   t, tt;          // Turn and turn velocity.
  int   rx;             // View space X position.
  int   ry;             // View space Y position
  int   rz;             // View space Z position
end;
  
    
global

  salida=false,
  res,i;
  TYetiKeyState mycontrol;

  TYPE_ENTITY_3D  mycam;
  
  
 end;

begin
          
  full_screen=TRUE;

  SET_FPS(0,0); //MAX ENGINE FPS
  set_mode (mode8_width,mode8_height,16);          
  
  graph= new_map(320,240,16);
  SET_CENTER(file,graph,0,0);//center bitmap
  x=0; y=0; z=45;
  
  //(texture,palette)      
   WRITE(0,10,20,0,"FPS: ");
   WRITE_INT(0,100,20,0,&FPS);
   
   yeti_init(file,graph,mycontrol, "media/e1m4.y3d","media/textures.raw", "media/textures.pal" );
     
	for (i=0;i<40;i++)	
	   crear_modelo(); 
	end;
	 
   //-------------------
   //logo_coldev();//grafico bennu
	
  while ( !salida )
     jkeys_controller();
     salida=(jkeys_state[_JKEY_MENU]); // Gp2x Wiz 'MENU'    
                  
         mycontrol.up= jkeys_state[_JKEY_UP];
	 mycontrol.down= jkeys_state[_JKEY_DOWN];
	 mycontrol.left= jkeys_state[_JKEY_LEFT];
	 mycontrol.right= jkeys_state[_JKEY_RIGHT];	 
     
     frame;                       
  end;               

  let_me_alone() ;
  
  //free resources
  yeti_FREE();
end


#define i2f(A) ((A)<<8)


process crear_modelo()
private
  entity_pos pos;
  bandera= -1;
  int model;
begin  
  model= yeti_addmodel("media/modelo.bin", &pos);
      
pos.yy= 0;
pos.zz= 0;  
pos.xx=0;

     pos.x= i2f(rand(2,63)) ; 
     pos.y= i2f(rand(2,63)) ;
	 pos.z= 0;
  loop   
	 	  
    if (rand(1,15)==5)	
     pos.yy= rand(1,15)*bandera;     
     pos.xx=rand(1,15)*bandera;
	 
	 if (rand(1,25)==13) bandera*=-1;  end; //retroceder
	end
  
    frame;
  end	
end; 

process logo_coldev() //bennu graph test
begin
  x=0;
  y=500;
  graph= load_png("media/coldev.png");
  loop
    x++; if (x > 800) x=0; end;
    	
    frame;
  end;
end;


